<?php
/*---------------------------------------------------+
| PHP-Fusion 6 Content Management System
+----------------------------------------------------+
| Copyright (c) 2005 Nick Jones
| http://www.php-fusion.co.uk/
+----------------------------------------------------+
| Released under the terms & conditions of v2 of the
| GNU General Public License. For details refer to
| the included gpl.txt file or visit http://gnu.org
+----------------------------------------------------*/

function parse_fortune($fname,$isrot13)
{
	$fh = fopen($fname,"r");
	$contents = fread ($fh, filesize ($fname));
	fclose($fh);
	if ($isrot13==true)
	{
		$contents=str_rot13("".$contents);
	}
	return explode("\n%",$contents);
}
function getDirList ($dirName)
{
	$list=array();
	$d = dir($dirName);
	while($entry = $d->read())
	{
		if ($entry != "." && $entry != "..")
		{
			if (is_dir($dirName."/".$entry))
			{
				$list=array_merge($list, getDirList($dirName."/".$entry));
			}
			else
			{
				$list[]=$dirName."/".$entry;
			}
		}
	}
	$d->close();
	return $list;
}
function selectCategories()
{
	$list=Array();
	$cursor = dbquery("SELECT a.category_pk, a.name, a.active,count(b.ref_category) as fortunes FROM ".DB_PREFIX."fortunes_cats a LEFT JOIN ".DB_PREFIX."fortunes_elems b ON a.category_pk = b.ref_category GROUP BY a.category_pk");
	while ($row=dbarray($cursor))
	{
		$tmp=new Category();
		$tmp->pk=$row['category_pk'];
		$tmp->name=$row['name'];
		$tmp->active=$row['active'];
		$tmp->fortunes=$row['fortunes'];
		$list[]=$tmp;
	}
	return $list;
}
function insertCategory($name)
{
	return dbquery("INSERT INTO ".DB_PREFIX."fortunes_cats (name) VALUES ('".$name."')");
}
function deleteCategory($pk)
{
	return  dbquery("DELETE FROM ".DB_PREFIX."fortunes_elems WHERE ref_category=".$pk) &&
	dbquery("DELETE FROM ".DB_PREFIX."fortunes_cats WHERE category_pk=".$pk) ;
	
}
function purgeCategory($pk)
{
	return  dbquery("DELETE FROM ".DB_PREFIX."fortunes_elems WHERE ref_category=".$pk);
}

function switchCategory($pk)
{
	$cursor=dbquery("select active FROM ".DB_PREFIX."fortunes_cats WHERE category_pk=".$pk);
	$row=dbarray($cursor);
	$flag=($row['active']+1)%2;
	dbquery("UPDATE ".DB_PREFIX."fortunes_cats SET active='".$flag."' WHERE category_pk=".$pk ) ;
}

function selectFortunesByCategory($pk)
{
	$list=Array();
	$cursor = dbquery("SELECT ref_category,text FROM ".DB_PREFIX."fortunes_elems WHERE ref_category=".$pk);
	while ($row=dbarray($cursor))
	{
		$tmp=new Fortune();
		$tmp->ref=$row['ref_category'];
		$tmp->text=$row['text'];
		$list[]=$tmp;
	}
	return $list;
}
function insertFortunesIntoCategory($pk,$textvector)
{
	foreach($textvector as $item)
	{
		$item=trim($item);
		if($item!="")
		{
			dbquery("INSERT INTO ".DB_PREFIX."fortunes_elems (ref_category,text) VALUES ('".$pk."','".mysql_escape_string($item)."')");
		}
	}
}

Class Category
{
	var $pk;
	var $name;
	var $active;
	var $fortunes;
	function Category()
	{
		$this->pk=0;
		$this->name="";
		$this->active=0;
		$this->fortunes=0;
	}
}
Class Fortune
{
	var $ref;
	var $text;
	function Fortune()
	{
		$this->ref=0;
		$this->text="";
	}
}
?>